type tab_e = (codage option) array
(* table utile pour l'encodage, de taille 255, *)
(* Le codage de char_of_int(i) est stocké dans la case d'indice i *)
(* encapsulé par le constructuer Some  s'il existe, *)
(* cette case contient None sinon *)

let tab_e_from_arbre_d (a:arbre_d) : tab_e =
	(* hyp : *)
	(* calcule le tableau d'encodage associé à l'arbre a *)
	let t = Array.make 256 None in
	let rec aux (aa:arbre_d)(co:codage) :unit = 
		match aa with 
		| Feuille(c) -> t.(int_of_char c) <- Some(List.rev co)
		| Ndd (g,d) -> aux g (false::co); aux d (true::co); 
	in aux a []; t

let rec cod_from_char (t:tab_e)(c:char): codage =
	(* hyp : t a bien un codage enregistré pour c *)
	(* calcule le codage du caractère c selon t *)
	match t.(int_of_char c) with
		| None -> failwith ("erreur pour le caractère "^(String.make 1 c))
		| Some (co) -> co

